<id>
Advanced forum log analysis mod 
</id>

<version>
1.1 SP1.31
</version>

<mod info>
This mod nakes a more informative forum log analysis. You see the forum log analysis if you follow the link "View forum access log" in your admin center.

The mods makes following changes

- sort the IP's by number
- display names in IP list, instead of login names
- link to profiles in IP list
- better recognition of browsers
- recognition of robots
- sort the browsers by number
- links to browsers
- better recognition of operating system 
- sort the operating system by number
- list of visited pages is substituted by lists of top boards, top threads and top profiles
- sort the referring pages by number
- hard coded text moved to english.lng

Installation:

1. Upload the file ShowClick.pl to your source direction.
2. apply the mod

The sub ShowClicksLog of Admin.pl is moved to ShowClick.pl to make it easier to update this mod, if new browsers, robots, or operating system are supported.
You will have then only to make a new upload of ShowClick.pl and no deinstalltion of the former mod version is necessary.

</mod info>

<author>
louisle, Pyrrhon
</author>

<homepage>
http://www.archiboard.de
http://www.philtalk.de/
</homepage>

<edit file>
sources/SubList.pl
</edit file>

<search for>
'showclicks',"Admin.pl&ShowClickLog",
</search for>

<replace>
'showclicks',"ShowClicks.pl&ShowClickLog",
</replace>

<edit file>
sources/Subs.pl
</edit file>

<search for>
	fclose(LOG);

	if($action eq '') {
</search for>

<replace>
	fclose(LOG);

####	if($action eq '') {
</replace>

<search for>
		}
		fclose(LOG);
	}
</search for>

<replace>
		}
		fclose(LOG);
####	}
</replace>

<search for>
	print LOG "$field|$date|$ENV{'REQUEST_URI'}|$ENV{'HTTP_REFERER'}|$ENV{'HTTP_USER_AGENT'}\n";
</search for>

<replace>
#### Advanced Log Analysis ####
	$requrl=$ENV{'REQUEST_URI'};
	if($requrl =~ /start=/) {
		@newru=split(/;/,$requrl);
		pop(@newru);
		$requrl=join(";",@newru);
	}
	print LOG "$field|$date|$requrl|$ENV{'HTTP_REFERER'}|$ENV{'HTTP_USER_AGENT'}\n";
#### Advanced Log Analysis ####
</replace>

<edit file>
sources/Admin.pl
</edit file>

<search for>

sub ShowClickLog {
	&is_admin;
	my($totalip,$totalclick,$totalbrow,$totalos,@log,@iplist,$date,@to,@from,@info,@os,@browser,@newiplist,@newbrowser,@newoslist,@newtolist,@newfromlist,$i,$curentry);
	fopen(LOG, "$vardir/clicklog.txt");
	@log = <LOG>;
	fclose(LOG);

	$i = 0;
	foreach $curentry (@log) {
		($iplist[$i],$date,$to[$i],$from[$i],$info[$i]) = split(/\|/, $curentry);
		$i++;
	}
	$i = 0;
	foreach $curentry (@info) {
		if ($curentry !~ /\s\(Win/i || $curentry !~ /\s\(mac/) { $curentry =~ s/\s\((compatible;\s)*/ - /ig; }
		else { $curentry =~ s/(\S)*\(/; /g; }
		if ($curentry =~ /\s-\sWin/i) { $curentry =~ s/\s-\sWin/; win/ig; }
		if ($curentry =~ /\s-\sMac/i) { $curentry =~ s/\s-\sMac/; mac/ig; }
		($browser[$i],$os[$i]) = split(/\;\s/, $curentry);
		if($os[$i] =~ /\)\s\S/) { ($os[$i],$browser[$i]) = split(/\)\s/, $os[$i]); }
		$os[$i] =~ s/\)//g;
		$i++;
	}

	$yymain .= qq~
<table border=0 cellspacing=1 cellpadding="5" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td bgcolor="$color{'titlebg'}" class="titlebg">
    <img src="$imagesdir/info.gif" alt="" border="0">&nbsp;
    <font size=2 color="$color{'titletext'}"><b>$txt{'693'}</b></font></td>
  </tr><tr>
    <td bgcolor="$color{'windowbg'}" class="windowbg">
    <BR><font size="1">$txt{'697'}</font><BR><BR></td>
  </tr><tr>
    <td bgcolor="$color{'catbg'}" class="catbg">
    <font size=2><center><B>$txt{'694'}</B></center></font>
    </td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size="2">
~;
for($i = 0; $i < @iplist; $i++) { $iplist{$iplist[$i]}++; }
$i = 0;
while(($key, $val ) = each(%iplist)) {
	$newiplist[$i] = [ $key, $val ];
	$i++;
}
$totalclick = @iplist;
$totalip = @newiplist;
$yymain .=  qq~<i>$txt{'742'}: $totalclick</i><BR>~;
$yymain .=  qq~<i>$txt{'743'}: $totalip</i><BR><BR>~;
for($i = 0; $i < @newiplist; $i++) {
	if($newiplist[$i]->[0] =~ /\S+/) { $yymain .= "$newiplist[$i]->[0] &nbsp;(<i>$newiplist[$i]->[1]</i>)<BR>\n"; }
}
$yymain .= qq~
    </font></td>
  </tr><tr>
    <td bgcolor="$color{'catbg'}" class="catbg">
    <font size="2"><center><b>$txt{'695'}</b></center></font>
    </td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size="2">
~;
for($i = 0; $i < @browser; $i++) { $browser{$browser[$i]}++; }
$i = 0;
while(($key, $val ) = each(%browser)) {
	$newbrowser[$i] = [ $key, $val ];
	$i++;
}
$totalbrow = @newbrowser;
$yymain .=  qq~<i>$txt{'744'}: $totalbrow</i><BR><BR>~;
for($i = 0; $i < @newbrowser; $i++) {
	if($newbrowser[$i]->[0] =~ /\S+/) { $yymain .= "$newbrowser[$i]->[0] &nbsp;(<i>$newbrowser[$i]->[1]</i>)<BR>\n"; }
}
$yymain .= qq~
    </font></td>
  </tr><tr>
    <td bgcolor="$color{'catbg'}" class="catbg">

    <font size="2"><center><b>$txt{'696'}</b></center></font>
    </td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size="2">
~;
for($i = 0; $i < @os; $i++) { $os{$os[$i]}++; }
$i = 0;
while(($key, $val ) = each(%os) ) {
	$newoslist[$i] = [ $key, $val ];
	$i++;
}
$totalos = @newoslist;
$yymain .=  qq~<i>$txt{'745'}: $totalos</i><BR><BR>~;
for($i = 0; $i < @newoslist; $i++) {
	if($newoslist[$i]->[0] =~ /\S+/) { $yymain .= "$newoslist[$i]->[0] &nbsp;(<i>$newoslist[$i]->[1]</i>)<BR>\n"; }
}
$yymain .= qq~
    </font></td>
  </tr><tr>
    <td bgcolor="$color{'catbg'}" class="catbg">
    <font size="2"><center><b>Pages Visited</b></center></font>
    </td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size="2">
~;
for($i = 0; $i < @to; $i++) { $to{$to[$i]}++; }
$i = 0;
while(($key, $val ) = each(%to)) {
	$newtolist[$i] = [ $key, $val ];
	$i++;
}
for($i = 0; $i < @newtolist; $i++) {
	if($newtolist[$i]->[0] =~ /\S+/) { $yymain .= "<a href=\"$newtolist[$i]->[0]\" target=\"_blank\">$newtolist[$i]->[0]</a> &nbsp;(<i>$newtolist[$i]->[1]</i>)<BR>\n"; }
}
$yymain .= qq~
    </font></td>
  </tr><tr>
    <td bgcolor="$color{'catbg'}" class="catbg">
    <font size="2"><center><b>Referring Pages</b></center></font>
    </td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size="2">
~;
for($i = 0; $i < @from; $i++) { $from{$from[$i]}++; }
$i = 0;
while(($key, $val ) = each(%from)) {
	$newfromlist[$i] = [ $key, $val ];
	$i++;
}
for($i = 0; $i < @newfromlist; $i++) {
	if($newfromlist[$i]->[0] =~ /\S+/ && $newfromlist[$i]->[0] !~ m~$boardurl~i) { $yymain .= "<a href=\"$newfromlist[$i]->[0]\" target=\"_blank\">$newfromlist[$i]->[0]</a> &nbsp;(<i>$newfromlist[$i]->[1]</i>)<BR>\n"; }
}
$yymain .= qq~
    </font></td>
  </tr>
</table>
~;
	$yytitle = $txt{'693'};
	&template;
	exit;
}

</search for>

<replace>

# advanced forum log analysis mod
#	sub ShowClickLog is moved into ShowClicks.pl to make updates easier
# end advanced forum log analysis mod

</replace>

<edit file>
english.lng
</edit file>

<search for>
1;
</search for>

<add before>

# Advanced Log Analysis Mod
%showclicktxt=(
'1' => "Top Forums",
'2' => "Top Threads",
'3' => "Referring Pages",
'4' => "Pages visited",
'5' => "Top Profiles"
);
# End Advanced Log Analysis Mod

</add before>